<SCRIPT LANGUAGE="VBScript" RUNAT="SERVER">
Response.Write "<HR><H3>Debugging Information</H3>"

Response.Write "<P><DIV><B>The Request.Form Collection</B></DIV>"
For Each objItem In Request.Form
   Response.Write objItem & " = " & Server.HTMLEncode(Request.Form(objItem)) & "<BR>"
Next

Response.Write "<P><DIV><B>The Request.QueryString Collection</B></DIV>"
For Each objItem In Request.QueryString
   Response.Write objItem & " = " & Server.HTMLEncode(Request.QueryString(objItem)) & "<BR>"
Next

Response.Write "<P><DIV><B>The Request.Cookies Collection</B></DIV>"
For Each objItem In Request.Cookies
   If Request.Cookies(objItem).HasKeys Then
      'use another For...Each to iterate all keys of dictionary
      For Each objItemKey in Request.Cookies(objItem)
         Response.Write objItem & "(" & objItemKey & ") = " _
                        & Server.HTMLEncode(Request.Cookies(objItem)(objItemKey)) & "<BR>"
      Next
   Else
      'print out the cookie string as normal
      Response.Write objItem & " = " & Server.HTMLEncode(Request.Cookies(objItem)) & "<BR>"
   End If
Next

Response.Write "<P><DIV><B>The Request.ClientCertificate Collection</B></DIV>"
For Each objItem In Request.ClientCertificate
   Response.Write objItem & " = " & Server.HTMLEncode(Request.ClientCertificate(objItem)) & "<BR>"
Next

Response.Write "<P><DIV><B>The Request.ServerVariables Collection</B></DIV>"
For Each objItem In Request.ServerVariables
   Response.Write objItem & " = " & Server.HTMLEncode(Request.ServerVariables(objItem)) & "<BR>"
Next

Response.Write "<P><DIV><B>The Application Object Contents</B></DIV>"
For Each objItem in Application.Contents
   If IsObject(Application.Contents(objItem)) Then
      Response.Write "Object reference: '" & objItem & "'<BR>"
   ElseIf IsArray(Application.Contents(objItem)) Then
      Response.Write "Array: '" & objItem & "' contents are:<BR>"
      varArray = Application.Contents(objItem)
      'note: the following only works with a one-dimensional array
      For intLoop = 0 To UBound(varArray)
         Response.Write "&nbsp; Index(" & intLoop & ") = " & Server.HTMLEncode(varArray(intLoop)) & "<BR>"
      Next
   Else
      Response.Write "Variable: '" & objItem & "' = " _
                     & Server.HTMLEncode(Application.Contents(objItem)) & "<BR>"
   End If
Next
For Each objItem in Application.StaticObjects
   If IsObject(Application.StaticObjects(objItem)) Then
      Response.Write "&lt;OBJECT&gt; element: ID='" & objItem & "'<BR>"
   End if
Next

Response.Write "<P><DIV><B>The Session Object Contents</B></DIV>"
For Each objItem in Session.Contents
   If IsObject(Session.Contents(objItem)) Then
      Response.Write "Object reference: '" & objItem & "'<BR>"
   ElseIf IsArray(Session.Contents(objItem)) Then
      Response.Write "Array: '" & objItem & "' contents are:<BR>"
      varArray = Session.Contents(objItem)
      'note: the following only works with a one-dimensional array
      For intLoop = 0 To UBound(varArray)
         Response.Write "&nbsp; Index(" & intLoop & ") = " & Server.HTMLEncode(varArray(intLoop)) & "<BR>"
      Next
   Else
      Response.Write "Variable: '" & objItem & "' = " _
                     & Server.HTMLEncode(Session.Contents(objItem)) & "<BR>"
   End If
Next
For Each objItem in Session.StaticObjects
   If IsObject(Session.StaticObjects(objItem)) Then
      Response.Write "&lt;OBJECT&gt; element: ID='" & objItem & "'<BR>"
   End if
Next

Response.Write "<HR>"

</SCRIPT>
